//
// Created by robin on 7/22/16.
//

#ifndef LIBNFC_CPPTOOLS_SECTORDBO_H
#define LIBNFC_CPPTOOLS_SECTORDBO_H


#include <string>
#include <libnfc_cpptools/Result.h>
#include <libnfc_cpptools/FreeFareAccessBits.h>

namespace LibNfc
{
namespace FreeFare
{

class FreeFareSector
{
public:
    explicit FreeFareSector(const std::string& data = "");
    ~FreeFareSector() = default;

    const std::string& getBlock(int block) const;

    std::string getKeyA() const;

    std::string getKeyB() const;

    std::string getAccessBits() const;

    FreeFareAccessBits getAccessBitsDbo() const;

    void setBlock(int block, const std::string& data);

    void setKeyA(const std::string& key);

    void setKeyB(const std::string& key);

    void setAccessBits(const std::string& accessBits);

    void setAccessBits(const FreeFareAccessBits& accessBits);

    bool hasBlock(int block) const;

    bool hasKeyA() const;

    bool hasKeyB() const;

    bool hasAccessBits() const;

protected:
    std::string _blocks[4];

    bool _haveBlocks[4];

    bool _hasKeyA;

    bool _hasKeyB;

    bool _hasAccessBits;
};

}; // FreeFare
}; // LibNfc

#endif //LIBNFC_CPPTOOLS_SECTORDBO_H
